# This is a custom distribution: a wedge-shaped frequency
# uniform from "m" until some changepoint "b",
# whereupon it declines linearly to 0 along a triangular distribution
# ending at point "M".


# rwedge: outputs "n" random draws
rwedge <- function(n,m,b,M)
{
	lunif <- runif(n,0,1) < 1/(1+(M-b)/(2*(M-m)))
	bprp <- (b-m)/(M-m)
	x <- ifelse(lunif, runif(sum(lunif),min = m,max = b),
		M-sqrt((1-runif(sum(1-lunif),min = bprp,max = 1))*(M-m)*(M-b)))
	return(x)
}

# dwedge: outputs density of distribution at point "x"
dwedge <- function(x,m,b,M)
{
	d <- vector(,length(x))
	bprp <- (b-m)/(M-m)
	d[x <= b] <- dunif(x[x <= b], m, b)*2*bprp
	d[x > b] <- 2*(M - x[x > b])/((M-m)*(M-b))
	return(d)
}
